/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.etools.c.CArray;
import com.ibm.etools.c.CDerivableType;
import com.ibm.etools.c.CPackage;
import com.ibm.etools.c.CTypedElement;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Array</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link com.ibm.etools.c.impl.CArrayImpl#getDimension <em>Dimension</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class CArrayImpl extends CDerivedImpl implements CArray {
    /**
     * The default value of the '{@link #getDimension() <em>Dimension</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getDimension()
     * @generated @ordered
     */
    protected static final Integer DIMENSION_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getDimension() <em>Dimension</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getDimension()
     * @generated @ordered
     */
    protected Integer dimension = DIMENSION_EDEFAULT;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected CArrayImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return CPackage.eINSTANCE.getCArray();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Integer getDimension() {
        return dimension;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setDimension(Integer newDimension) {
        Integer oldDimension = dimension;
        dimension = newDimension;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, CPackage.CARRAY__DIMENSION, oldDimension, dimension));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case CPackage.CARRAY__TD_LANG_TYPED_ELEMENT:
                return ((InternalEList) getTdLangTypedElement()).basicAdd(otherEnd, msgs);
            case CPackage.CARRAY__CONTAINER:
                if (eContainer != null)
                    msgs = eBasicRemoveFromContainer(msgs);
                return eBasicSetContainer(otherEnd, CPackage.CARRAY__CONTAINER, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case CPackage.CARRAY__TD_LANG_TYPED_ELEMENT:
                return ((InternalEList) getTdLangTypedElement()).basicRemove(otherEnd, msgs);
            case CPackage.CARRAY__CONTAINER:
                return eBasicSetContainer(null, CPackage.CARRAY__CONTAINER, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
        if (eContainerFeatureID >= 0) {
            switch (eContainerFeatureID) {
            case CPackage.CARRAY__CONTAINER:
                return ((InternalEObject) eContainer).eInverseRemove(this, CPackage.CTYPED_ELEMENT__CONTAINS, CTypedElement.class, msgs);
            default:
                return eDynamicBasicRemoveFromContainer(msgs);
            }
        }
        return ((InternalEObject) eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CARRAY__NAME:
            return getName();
        case CPackage.CARRAY__TD_LANG_TYPED_ELEMENT:
            return getTdLangTypedElement();
        case CPackage.CARRAY__DERIVES:
            if (resolve)
                return getDerives();
            return basicGetDerives();
        case CPackage.CARRAY__CONTAINER:
            return getContainer();
        case CPackage.CARRAY__DIMENSION:
            return getDimension();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CARRAY__NAME:
            setName((String) newValue);
            return;
        case CPackage.CARRAY__TD_LANG_TYPED_ELEMENT:
            getTdLangTypedElement().clear();
            getTdLangTypedElement().addAll((Collection) newValue);
            return;
        case CPackage.CARRAY__DERIVES:
            setDerives((CDerivableType) newValue);
            return;
        case CPackage.CARRAY__CONTAINER:
            setContainer((CTypedElement) newValue);
            return;
        case CPackage.CARRAY__DIMENSION:
            setDimension((Integer) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CARRAY__NAME:
            unsetName();
            return;
        case CPackage.CARRAY__TD_LANG_TYPED_ELEMENT:
            getTdLangTypedElement().clear();
            return;
        case CPackage.CARRAY__DERIVES:
            setDerives((CDerivableType) null);
            return;
        case CPackage.CARRAY__CONTAINER:
            setContainer((CTypedElement) null);
            return;
        case CPackage.CARRAY__DIMENSION:
            setDimension(DIMENSION_EDEFAULT);
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CARRAY__NAME:
            return isSetName();
        case CPackage.CARRAY__TD_LANG_TYPED_ELEMENT:
            return tdLangTypedElement != null && !tdLangTypedElement.isEmpty();
        case CPackage.CARRAY__DERIVES:
            return derives != null;
        case CPackage.CARRAY__CONTAINER:
            return getContainer() != null;
        case CPackage.CARRAY__DIMENSION:
            return DIMENSION_EDEFAULT == null ? dimension != null : !DIMENSION_EDEFAULT.equals(dimension);
        }
        return eDynamicIsSet(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public String toString() {
        if (eIsProxy())
            return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (dimension: ");
        result.append(dimension);
        result.append(')');
        return result.toString();
    }

} //CArrayImpl
